import { world, system, ItemStack } from "@minecraft/server"
import { durability } from "../durabilityRemove.js"

const shovel = [
    "minecraft:grass_block",
    "minecraft:dirt",
    "minecraft:dirt_with_roots",
    "minecraft:coarse_dirt",
    "minecraft:mycelium",
    "minecraft:podzol"
]

const hoe = [
    "minecraft:grass_block",
    "minecraft:dirt",
    "minecraft:grass_path"
]

const overworld_logs = [
    "minecraft:oak_log",
    "minecraft:spruce_log",
    "minecraft:birch_log",
    "minecraft:jungle_log",
    "minecraft:acacia_log",
    "minecraft:dark_oak_log",
    "minecraft:mangrove_log",
    "minecraft:cherry_log",
    "minecraft:pale_oak_log",
    "minecraft:oak_wood",
    "minecraft:spruce_wood",
    "minecraft:birch_wood",
    "minecraft:jungle_wood",
    "minecraft:acacia_wood",
    "minecraft:dark_oak_wood",
    "minecraft:mangrove_wood",
    "minecraft:cherry_wood",
    "minecraft:pale_oak_wood",
    "minecraft:bamboo_block"
]

const nether_logs = [
    "minecraft:crimson_stem",
    "minecraft:warped_stem",
    "minecraft:crimson_hyphae",
    "minecraft:warped_hyphae"
]

world.beforeEvents.itemUseOn.subscribe(({ block, itemStack, source: player }) => {
    if (itemStack.typeId.includes("thini:aiots_")) {
        if (overworld_logs.includes(block.typeId) || overworld_logs.includes(block.typeId) && player.getGameMode() == "survival") system.run(() => durability(itemStack, player))
        if (overworld_logs.includes(block.typeId)) return system.run(() => block.dimension.playSound("use.wood", block.location))
        if (nether_logs.includes(block.typeId)) return system.run(() => block.dimension.playSound("use.stem", block.location))
    }
})


world.afterEvents.playerBreakBlock.subscribe(({ itemStackBeforeBreak: item, player }) => {
    if (item?.typeId.includes("thini:aiots_")) durability(item, player)
})


world.beforeEvents.worldInitialize.subscribe((data) => {
    data.itemComponentRegistry.registerCustomComponent("thini:aiots", {
        onUseOn: ((event) => {
            const { block, itemStack, source: player } = event
            const { x, y, z } = block.location
            if (!player.isSneaking && shovel.includes(block.typeId)) {
                if (player.getGameMode() == "survival") system.run(() => durability(itemStack, player))
                block.dimension.playSound("use.grass", block.location)
                block.dimension.setBlockType(block.location, "minecraft:grass_path")
                return
            }
            if (player.isSneaking && hoe.includes(block.typeId)) {
                if (player.getGameMode() == "survival") system.run(() => durability(itemStack, player))
                block.dimension.playSound("use.gravel", block.location)
                block.dimension.setBlockType(block.location, "minecraft:farmland")
                return
            }
            if (block.typeId == "minecraft:coarse_dirt" || block.typeId == "minecraft:dirt_with_roots") {
                if (player.getGameMode() == "survival") system.run(() => durability(itemStack, player))
                if (block.typeId == "minecraft:dirt_with_roots") block.dimension.spawnItem(new ItemStack("minecraft:hanging_roots", 1), block.location)
                block.dimension.playSound("use.grass", block.location)
                block.dimension.setBlockType(block.location, "minecraft:dirt")
                return
            }
        })
    })
})