import { world, ItemStack } from '@minecraft/server'

export function durability(item, player) {
    if (!item.hasComponent("durability")) return

    const durability = item.getComponent("durability")
    const enchantment = item.getComponent("enchantable")
    let unbreaking = 0
    enchantment.hasEnchantment("unbreaking") ? unbreaking = Math.floor(100-(100/(enchantment.getEnchantment("unbreaking").level +1))): null

    if (unbreaking == 0) {
        removeDurability(item, durability, player)
    } else if (Math.floor(Math.random() * 100) > unbreaking) {
        removeDurability(item, durability, player)
    }
}

function removeDurability(item, durability, player) {
    if (durability.damage +1 <= durability.maxDurability) {
        durability.damage = durability.damage +1
        player.getComponent("equippable").setEquipment("Mainhand", item)
    } else {
        player.getComponent("equippable").setEquipment("Mainhand", new ItemStack("minecraft:air", 1))
        player.playSound("random.break", {...player.location})
    }
}